/*
 =================== DO NOT EDIT THIS FILE ====================
 Generated by Modello 1.0.2 on 2011-06-10 08:15:47,
 any modifications will be overwritten.
 ==============================================================
 */

package org.sonatype.security.legacy.model.v1_0_0;

/**
 * A User is a security object, where, based upon its role, will
 * have certain privileged access to the system.
 * 
 * @version $Revision$ $Date$
 */
public class CUser
    implements java.io.Serializable
{

      //--------------------------/
     //- Class/Member Variables -/
    //--------------------------/

    /**
     * The userId that will be used to gain access to the system.
     */
    private String userId;

    /**
     * Users real life name.
     */
    private String name;

    /**
     * Users password, note this is just the hash of the password,
     * not the actual password.
     */
    private String password;

    /**
     * The current status of this user, active/locked/disabled.
     */
    private String status;

    /**
     * The user's email address.
     */
    private String email;

    /**
     * Field roles.
     */
    private java.util.List<String> roles;


      //-----------/
     //- Methods -/
    //-----------/

    /**
     * Method addRole.
     * 
     * @param string
     */
    public void addRole( String string )
    {
        if ( !(string instanceof String) )
        {
            throw new ClassCastException( "CUser.addRoles(string) parameter must be instanceof " + String.class.getName() );
        }
        getRoles().add( string );
    } //-- void addRole( String )

    /**
     * Get the user's email address.
     * 
     * @return String
     */
    public String getEmail()
    {
        return this.email;
    } //-- String getEmail()

    /**
     * Get users real life name.
     * 
     * @return String
     */
    public String getName()
    {
        return this.name;
    } //-- String getName()

    /**
     * Get users password, note this is just the hash of the
     * password, not the actual password.
     * 
     * @return String
     */
    public String getPassword()
    {
        return this.password;
    } //-- String getPassword()

    /**
     * Method getRoles.
     * 
     * @return List
     */
    public java.util.List<String> getRoles()
    {
        if ( this.roles == null )
        {
            this.roles = new java.util.ArrayList<String>();
        }

        return this.roles;
    } //-- java.util.List<String> getRoles()

    /**
     * Get the current status of this user, active/locked/disabled.
     * 
     * @return String
     */
    public String getStatus()
    {
        return this.status;
    } //-- String getStatus()

    /**
     * Get the userId that will be used to gain access to the
     * system.
     * 
     * @return String
     */
    public String getUserId()
    {
        return this.userId;
    } //-- String getUserId()

    /**
     * Method removeRole.
     * 
     * @param string
     */
    public void removeRole( String string )
    {
        if ( !(string instanceof String) )
        {
            throw new ClassCastException( "CUser.removeRoles(string) parameter must be instanceof " + String.class.getName() );
        }
        getRoles().remove( string );
    } //-- void removeRole( String )

    /**
     * Set the user's email address.
     * 
     * @param email
     */
    public void setEmail( String email )
    {
        this.email = email;
    } //-- void setEmail( String )

    /**
     * Set users real life name.
     * 
     * @param name
     */
    public void setName( String name )
    {
        this.name = name;
    } //-- void setName( String )

    /**
     * Set users password, note this is just the hash of the
     * password, not the actual password.
     * 
     * @param password
     */
    public void setPassword( String password )
    {
        this.password = password;
    } //-- void setPassword( String )

    /**
     * Set list of role ids that will define this user.
     * 
     * @param roles
     */
    public void setRoles( java.util.List<String> roles )
    {
        this.roles = roles;
    } //-- void setRoles( java.util.List )

    /**
     * Set the current status of this user, active/locked/disabled.
     * 
     * @param status
     */
    public void setStatus( String status )
    {
        this.status = status;
    } //-- void setStatus( String )

    /**
     * Set the userId that will be used to gain access to the
     * system.
     * 
     * @param userId
     */
    public void setUserId( String userId )
    {
        this.userId = userId;
    } //-- void setUserId( String )


    public static final String STATUS_DISABLED = "disabled";
    
    public static final String STATUS_ACTIVE = "active";
    
    //Not currently supported
    //public static final String STATUS_LOCKED = "locked";
    
    //public static final String STATUS_EXPIRED = "expired";

}
